<template>
  <transition-group
    name="list"
    :class="['notifies', hasMore ? 'show' : '']"
    tag="ul"
  >
    <div v-for="(item, key) of notifies" :key="item" class="toast">
      <span>{{ item.title }}</span>
      <button class="toast__close" @click="removeNotify(key)">
        <img src="@/assets/images/icon_close.svg" alt="close toast" />
      </button>
    </div>
  </transition-group>
</template>

<script setup>
import { defineProps, defineEmits, computed } from 'vue';

const props = defineProps({
  notifies: Array
});

const hasMore = computed(() => {
  return props.notifies.length > 0;
});

const emit = defineEmits(['update:notifies']);

const autoHide = () => {
  setInterval(() => {
    removeNotify(0);
  }, 3000);
};

const removeNotify = (index) => {
  let notify = props.notifies;
  notify.splice(index, 1);
  emit('update:notifies', notify);
};

setTimeout(() => {
  autoHide();
}, 3000);
</script>

<style lang="scss" scoped>
.notifies {
  position: fixed;
  top: 0;
  right: 0;
  height: 100vh;
  width: 400px;
  padding: 5px;
  z-index: -1;

  &.show {
    z-index: 1000;
  }
}

@mixin flexCenter {
  display: flex;
  align-items: center;
}

.toast {
  @include flexCenter();
  position: relative;
  padding: 12px;
  border-radius: 5px;
  box-shadow: 0px 7px 12px 2px rgba(0, 0, 0, 0.2);
  margin-bottom: 10px;
  width: 100%;
  justify-content: space-between;

  &__close {
    @include flexCenter();
    position: absolute;
    top: 3px;
    right: 3px;
    width: 25px;
    height: 25px;
    border-radius: 50%;
    justify-content: center;

    img {
      width: 20px;
      height: 20px;
    }
  }
}

.list-move, /* apply transition to moving elements */
.list-enter-active,
.list-leave-active {
  transition: all 0.5s ease;
}

.list-enter-from,
.list-leave-to {
  opacity: 0;
  transform: translateX(30px);
}

/* ensure leaving items are taken out of layout flow so that moving
   animations can be calculated correctly. */
.list-leave-active {
  position: absolute;
}
</style>
